
/*
 *
 * @param arg
 * @param arg2
 * @throw
 */
function File(arg, arg2) {
	
	this.nsIFile = null;
	
	//Construct object--------
	//alert(typeof(arg));
	try {
		if(typeof(arg) == "string") {
			//URL、パスから
			if(arg.match(/^file:\/\/.+/)) {
				var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
				this.nsIFile = fileHandler.getFileFromURLSpec(arg);
			} else {
				this.nsIFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				this.nsIFile.initWithPath(arg);
			}
		} else if(typeof(arg) == "object"
					&& (arg.toString().indexOf("nsILocalFile") >= 0 || arg.toString().indexOf("nsIFile") >= 0) ) {
			
			this.nsIFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			this.nsIFile.initWithPath(arg.path);
			
			if(arg2 && arg.isDirectory() && typeof(arg2) == "string") {
				this.nsIFile.append(arg2);
			}
		} else if(typeof(arg) == "object" && arg.toString().indexOf(CM_IO_FILE_ID) >= 0) {
			
			this.nsIFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			this.nsIFile.initWithPath(arg.getPath());
			
			if(arg2 && arg.isDirectory() && typeof(arg2) == "string") {
				this.nsIFile.append(arg2);
			}
			
		} else if(typeof(arg) == "number") {
			//Special File
			if(arg == CM_IO_MYEXTD) {
				this.nsIFile = Components.classes["@mozilla.org/extensions/manager;1"]
								.getService(Components.interfaces.nsIExtensionManager)
								.getInstallLocation(arg2)
								.getItemLocation(arg2); 
			} else {
				var spstr = null;
				switch(arg) {
					case CM_IO_PROFD : spstr = "ProfD"; break;
					case CM_IO_DEFPROFRT : spstr = "DefProfRt"; break;
					case CM_IO_UCHRM : spstr = "UChrm"; break;
					case CM_IO_DEFRT : spstr = "DefRt"; break;
					case CM_IO_PRFDEF : spstr = "PrfDef "; break;
					case CM_IO_PROFDEFNOLOC : spstr = "ProfDefNoLoc"; break;
					case CM_IO_APLUGNS : spstr = "APlugns"; break;
					case CM_IO_ACHROM : spstr = "AChrom"; break;
					case CM_IO_COMSD : spstr = "ComsD"; break;
					case CM_IO_CURPROCD : spstr = "CurProcD"; break;
					case CM_IO_HOME : spstr = "Home "; break;
					case CM_IO_TMPD : spstr = "TmpD "; break;
				}
				
				if(spstr) {
					this.nsIFile = Components.classes["@mozilla.org/file/directory_service;1"]
									.getService(Components.interfaces.nsIProperties)
									.get(spstr, Components.interfaces.nsIFile);
				}
			}
		}
		
		if(!this.nsIFile) {
			throw "[File@sakura.ken]\n構築失敗。\n" + arg.toString();
		}
	} catch(e) {
		throw e;
	}
	//------------------------
	
	/*
	 *
	 *
	 */
	this.establishInputStream = function() {
		var istream = null;
		
		try {
			var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
		                        .createInstance(Components.interfaces.nsIFileInputStream);
	        
			istream.init(this.nsIFile, 0x01, 0755, 0);
		} catch(e) {
			throw e;
		}
		
		return istream;
	}
	
	/*
	 *
	 * @param charset
	 * @return
	 */
	this.establishConverterOutputStream = function(charset) {
		var conout = null;
		
		try {
			var fout = this.establishOutputStream();
			
			conout = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
							.createInstance(Components.interfaces.nsIConverterOutputStream);
						
		    conout.init(fout, charset, 0, 0x0000);
	    } catch(e) {
	    	throw e;
	    }
	    
	    return conout;
	}
	
	/*
	 *
	 * @return
	 */
	this.establishOutputStream = function() {
		var fout = null;
		try {
			//if(!this.nsIFile.exists()) {
			//	this.nsIFile.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
			//}
			
			fout = Components.classes["@mozilla.org/network/file-output-stream;1"]
	        	                .createInstance(Components.interfaces.nsIFileOutputStream);
	    
	    	fout.init(this.nsIFile, 0x02|0x08|0x20, 0755, 0);
	    
	    } catch(e) {
	    	throw e;
	    }
	    
	    return fout;
	}
	
	/*
	 *
	 * @return
	 */
	this.exist = function() {
		var exist = false;
		
		try {
			exist = this.nsIFile.exists();
		} catch(e) {
			alert(e);
		}
		
		return exist;
	}
	
	/*
	 * 拡張子を返します。
	 *
	 * @return
	 */
	this.getExt = function() {
		var name = this.nsIFile.leafName;
		var ext = "";
		
		if(name.match(/\.([^\.]+)$/)) {
			ext = RegExp.$1;
			ext = ext.toLowerCase();
		}
		
		return ext;
	}
	
	/*
	 *
	 * @return
	 */
	this.getName = function() {
		return this.nsIFile.leafName;
	}
	
	/*
	 *
	 * @return
	 */
	this.getPath = function() {
		return this.nsIFile.path;
	}
	
	/*
	 *
	 * @return
	 */
	this.getParentFile = function() {
		var pfile = new File(this.nsIFile.parent);
		
		return pfile;
	}
	
	/*
	 *
	 * @return
	 */
	this.getUrlSpec = function() {
		var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
		var url = fileHandler.getURLSpecFromFile(this.nsIFile);
		
		return url;
	}
	
	
	/*
	 *
	 */
	this.isDirectory = function() {
		var dir = false;
		
		try {
			dir = this.nsIFile.isDirectory();
		} catch(e) {
			alert(e);
		}
		
		return dir;
	}
	
	/*
	 *
	 */
	this.hasFile = function() {
		var entries = this.nsIFile.directoryEntries;
		
		return entries.hasMoreElements();
	}
	
	/*
	 *
	 */
	this.listFile = function() {
		var files = [];
		var entries = this.nsIFile.directoryEntries;
		
		while(entries.hasMoreElements()) {
			var entry = entries.getNext();
			entry.QueryInterface(Components.interfaces.nsIFile);
			var file = new File(entry);
			files.push(file);
		}
		
		return files;
	}
	
	/*
	 *
	 */
	this.mkdir = function() {
		if(!this.nsIFile.exists() || !this.nsIFile.isDirectory()) {
			this.nsIFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);
		}
	}
	
	/*
	 *
	 * @return
	 */
	this.size = function() {
		return this.nsIFile.fileSize;
	}
	
	/*
	 *
	 * @return
	 */
	this.toString = function() {
		return CM_IO_FILE_ID;
	}
	
}