/*
 * キャッシュディレクトリを選択。
 */
function chooseCacheDir() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
        .createInstance(nsIFilePicker);
	fp.init(window, "Select a cache directory", nsIFilePicker.modeGetFolder);
	
	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
	  var file = new File(fp.file);
	  
	  document.getElementById("text_cache").value = file.getUrlSpec();
	}
}

/*
 * OKボタン押下時
 */
function doOk() {
	var host = document.getElementById("text_host").value;
	var port = document.getElementById("text_port").value;
	var cache = document.getElementById("text_cache").value;
	var pubgate = document.getElementById("public_gateway_mode").checked;
	
	setPref("moonfox.host", host);
	setPref("moonfox.port", port);
	setPref("moonfox.cachedir", cache);
	setPref("moonfox.public_gateway_mode", pubgate);
	
	if(window.arguments && window.arguments[0]) {
		window.arguments[0].ok = true;
	}
	
	return true;
}

/*
 * 初期処理
 */
function startup() {
	var host = getPref("moonfox.host");
	var port = getPref("moonfox.port");
	var cache = getPref("moonfox.cachedir");
	var pubgate = getPref("moonfox.public_gateway_mode");
	
	document.getElementById("text_host").value = host;
	document.getElementById("text_port").value = port;
	document.getElementById("text_cache").value = cache;
	document.getElementById("public_gateway_mode").checked = pubgate;
}